/*
 * Copyright (c) 2009-2011 Emmanuel Vadot <elbarto@homebrewdev.org>
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* $Id: types.h,v 1.6 2011/01/25 16:21:30 elbarto Exp $ */

/*! \file types.h
    \brief types definitions

*/

/*! \var typedef unsigned char u8
    \brief typedef for a unsigned 8bits variable
*/

/*! \var typedef unsigned short u16
    \brief typedef for a unsigned 16 bits variable
*/

/*! \var typedef unsigned long u32
    \brief typedef for a unsigned 32bits variable
*/

/*! \var typedef signed char s8
    \brief typedef for a signed 8bits variable
*/

/*! \var typedef signed short s16
    \brief typedef for a signed 16bits variable
*/

/*! \var typedef signed long s32
    \brief typedef for a signed 32bits variable
*/

#ifndef _TYPES_H_
# define _TYPES_H_

typedef unsigned char	u8;
typedef unsigned short	u16;
typedef unsigned long	u32;

typedef signed char	s8;
typedef signed short	s16;
typedef signed long	s32;

#endif /* _TYPES_H_ */
